unit TGDialog;
interface
uses Objects,Drivers,TGDriver,TGViews,TGMouse;
const bfNormal     = $00 ;{normales nicht aktiviertes Schaltfeld}
      bfDefault    = $01 ;{Vorgabegem aktiviertes Schaltfeld   }
      bfLeftJust   = $02 ;{Schalterbeschriftung links ausgerichtet}
      bfBroadcast  =   4 ;
      scHandButtonShape  =  10 ;
      scHandClusterShape =  11 ;
      scFederShape       =  12 ;

  CDialog = #32#33#34#35#36#37#38#39#40#41#42#43#44#45#46#47#48#49#50#51#52+
            #53#54#55#56#57#58#59#60#61#62#63#64#65#66#67#68#69#70#71#72#73+
            #74#75#76#77;

type PSItem = ^TSItem;
     TSItem = record
       Value: PString;
       Next: PSItem;
     end;

     PButton = ^TButton;
     TButton = object(TView)
       Title: PString;
       Command: Word;
       Flags: Byte;
       oldcolor:word;
       AMDefault: Boolean;
       constructor Init(var Bounds: TRect; ATitle: TTitleStr; ACommand: Word; AFlags: Byte);
       constructor load(var S:Tstream);
       destructor done; virtual;
       procedure ButtonDraw(neu,oben:boolean);
       procedure Draw; virtual;
       function GetPalette: PPalette; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure MakeDefault(Enable: Boolean);
       procedure Press; virtual;
       procedure SetState(AState: Word; Enable: Boolean); virtual;
       procedure Store(var S: TStream);
     end;

     PCluster = ^TCluster;
     TCluster = object(TView)
       Value: Word;
       Sel: Integer;
       Strings: TStringCollection;
       constructor Init(var Bounds: TRect; AStrings: PSItem);
       constructor Load(var S: TStream);
       destructor Done; virtual;
       function DataSize: Word; virtual;
       procedure DrawBox(eckig:boolean);
       procedure GetData(var Rec); virtual;
       function GetHelpCtx: Word; virtual;
       function GetPalette: PPalette; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       function Mark(Item: Integer):Boolean; virtual;
       procedure MovedTo(Item: Integer); virtual;
       procedure Press(Item: Integer); virtual;
       procedure SetData(var Rec); virtual;
       procedure SetState(AState:Word; Enable: Boolean); virtual;
       procedure Store(var S:TStream);
       procedure ReDraw(nr:word;eckig:boolean);
       function GetPositionItem(where:TPoint):word;
       procedure setsel(neusel:word);
       function art:boolean; virtual;
       function HotKey(KeyCode: Word): word;
       function FindItem(Ch:Char): word;
     end;

     PCheckBoxes = ^TCheckBoxes;
     TCheckBoxes = object(TCluster)
       procedure Draw; virtual;
       function Mark(Item: Integer): Boolean; virtual;
       procedure Press(Item: Integer); virtual;
     end;

     PRadioButtons = ^TRadioButtons;
     TRadioButtons = object(TCluster)
       procedure Draw; virtual;
       function Mark(Item: Integer): Boolean; virtual;
       procedure MovedTo(Item: Integer); virtual;
       procedure Press(Item: Integer); virtual;
       function art:boolean; virtual;
       procedure SetData(var Rec); virtual;
     end;

     PDialog = ^TDialog;
     TDialog = object(TWindow)
       constructor Init(var Bounds: TRect; ATitle: TTitleStr);
       procedure HandleEvent(var Event:Tevent); virtual;
       function GetPalette: PPalette; virtual;
       function valid(command: Word): Boolean; virtual;
     end;

     PInputLine = ^TInputLine;
     TInputLine = object(TView)
       Data: PString;
       MaxLen: Integer;
       CurPos: Integer;
       FirstPos: Integer;
       SelStart: Integer;
       SelEnd: Integer;
       dy : byte;
       constructor Init(var Bounds: TRect; AMaxLen: Integer);
       constructor Load(var S: TStream);
       destructor Done; virtual;
       function DataSize:Word; virtual;
       procedure GetData(var Rec); virtual;
       function GetPalette: PPalette; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure SelectAll(Enable: Boolean);
       procedure SetData(var Rec); virtual;
       procedure SetState(AState: Word; Enable: Boolean); virtual;
       procedure Store(var S: TStream);
       procedure Draw; virtual;
     end;

     PStaticText = ^TStaticText;
     TStaticText = object(TView)
       Text: PString;
       constructor Init(var Bounds: TREct; ATExt: String);
       constructor Load(var S: TStream);
       destructor Done; virtual;
       procedure Draw; virtual;
       function GetPalette: PPalette; virtual;
       procedure GetText(var S: String); virtual;
       function getfarbe:word; virtual;
       procedure Store(var S: TStream);
     end;

     PLabel = ^TLabel;
     TLabel = object(TStaticText)
       Link: PView;
       Light: Boolean;
       constructor Init(var Bounds: TRect; AText: String; ALink: PView);
       constructor Load(var S: TStream);
       function GetPalette: PPAlette; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       procedure Store(var S:TStream); virtual;
       function getfarbe:word; virtual;
     end;

     TListBoxRec= record
       list:PCollection;
       focused:word;
     end;

     PListBox = ^PListBox;
     TListBox = object(TListViewer)
       List:PCollection;
       constructor Init(var Bounds: TRect; ANumCols: Word; AScrollBar: PScrollBar);
       constructor Load(var S: TStream);
       function DataSize: Word; virtual;
       procedure GetData(var Rec); virtual;
       function GetText(Item: Integer; MaxLen: Integer): String; virtual;
       procedure NewList(AList: PCollection); virtual;
       procedure SetData(var Rec); virtual;
       procedure Store(var S: TStream);
     end;

     PParamText = ^TParamText;
     TParamText = object(TStaticText)
       ParamCount: Integer;
       ParamList: Pointer;
       constructor Init(var Bounds: TRect; AText: String; AParamCount: Integer);
       constructor Load(var S: TStream);
       function DataSize: Word; virtual;
       procedure GetText(var S: String); virtual;
       procedure SetData(var Rec); virtual;
       procedure Store(var S: TStream);
     end;


function NewSItem(Str: String; ANext: PSItem): PSItem;
procedure RegisterDialogs;

implementation
const cmGrabDefault=66;
      cmReleaseDefault=67;

function NewSItem(Str: String; ANext: PSItem): PSItem;
var SItem:PSItem;
begin
  new(SItem);
  SItem^.Value:=NewStr(str);
  SItem^.Next:=ANext;
  NewSItem:=SItem;
end;

procedure RegisterDialogs;
const RDialog:TStreamRec = (
        ObjType:110;
        VmtLink: Ofs(TypeOf(TDialog)^);
        Load: @TDialog.Load;
        Store: @TDialog.Store);
      RInputLine:TStreamRec = (
        ObjType:111;
        VmtLink: Ofs(TypeOf(TInputLine)^);
        Load: @TInputLine.Load;
        Store: @TInputLine.Store);
      RButton:TStreamRec = (
        ObjType:112;
        VmtLink: Ofs(TypeOf(TButton)^);
        Load: @TButton.Load;
        Store: @TButton.Store);
      RCluster:TStreamRec = (
        ObjType:113;
        VmtLink: Ofs(TypeOf(TCluster)^);
        Load: @TCluster.Load;
        Store: @TCluster.Store);
      RRadioButtons:TStreamRec = (
        ObjType:114;
        VmtLink: Ofs(TypeOf(TRadioButtons)^);
        Load: @TRadioButtons.Load;
        Store: @TRadioButtons.Store);
      RCheckBoxes:TStreamRec = (
        ObjType:115;
        VmtLink: Ofs(TypeOf(TCheckBoxes)^);
        Load: @TCheckBoxes.Load;
        Store: @TCheckBoxes.Store);
      RListBox:TStreamRec = (
        ObjType:116;
        VmtLink: Ofs(TypeOf(TListBox)^);
        Load: @TListBox.Load;
        Store: @TListBox.Store);
      RStaticText:TStreamRec = (
        ObjType:117;
        VmtLink: Ofs(TypeOf(TStaticText)^);
        Load: @TStaticText.Load;
        Store: @TStaticText.Store);
      RLabel:TStreamRec = (
        ObjType:118;
        VmtLink: Ofs(TypeOf(TLabel)^);
        Load: @TLabel.Load;
        Store: @TLabel.Store);
      RParamText:TStreamRec = (
        ObjType:120;
        VmtLink: Ofs(TypeOf(TParamText)^);
        Load: @TParamText.Load;
        Store: @TParamText.Store);
begin
  RegisterType(RDialog);
  RegisterType(RInputLine);
  RegisterType(RButton);
  RegisterType(RCluster);
  RegisterType(RRadioButtons);
  RegisterType(RCheckBoxes);
  RegisterType(RListBox);
  RegisterType(RStaticText);
  RegisterType(RLabel);
  RegisterType(RParamText);
end;

constructor TButton.Init(var Bounds: TRect; ATitle: TTitleStr; ACommand: Word; AFlags: Byte);
begin
  TView.Init(Bounds);
  Title:=NewStr(ATitle);
  Command:=ACommand;
  Flags:=AFlags;
  AmDefault:=AFlags and bfDefault>0;
  Options:=Options or ofSelectable or ofFirstClick or ofPostProcess or ofPreProcess;
  EventMask:=EventMask or evBroadCast or evMouseUp;
  if not CommandEnabled(ACommand) then state:=state or sfDisabled;
  positionctx:=scHandbuttonShape;
  oldcolor:=0;
end;

procedure TButton.Store(var S: TStream);
begin
  TView.Store(s);
  s.writestr(title);
  s.write(command,sizeof(command));
  s.write(flags,(sizeof(flags)));
end;

constructor TButton.load(var S:Tstream);
var len:byte;
    buf:array[0..255] of byte;
begin
  TView.Load(s);
  s.read(len,sizeof(byte));
  title:=s.readstr;
  s.read(command,sizeof(command));
  s.read(flags,(sizeof(flags)));
  AmDefault:=Flags and bfDefault>0;
end;

destructor TButton.done; 
begin
  DisposeStr(Title);
  TView.Done;
end;

procedure TButton.ButtonDraw(neu,oben:boolean);
var boxcolor,textcolor:word;
    r:TRect;
begin
  if getstate(sfvisible) then begin
    boxcolor:=getcolor(9*256+8);
    if commandenabled(command) then begin
      if selectpfad then begin
        textcolor:=getcolor(7*256+3);
      end else begin
        if amdefault then begin
          textcolor:=getcolor(6*256+2);
        end else begin
          textcolor:=getcolor(6*256+1);
        end;
      end;
    end else textcolor:=getcolor(5*256+4);
    if (oldcolor<>textcolor) or neu then begin
      getextent(r);
      if neu then schreibefeld(r.a.x,r.a.y,r.b.x,r.b.y,oben,flags and bfleftjust=0,title^,textcolor,boxcolor)
      else schreiberamen(r.a.x,r.a.y,r.b.x,r.b.y,oben,flags and bfleftjust=0,title^,textcolor,boxcolor);
      oldcolor:=textcolor;
    end;
  end;
end;

procedure TButton.Draw; 
begin
  ButtonDraw(true,true);
end;

function TButton.GetPalette: PPalette; 
const
  CButton = #13#14#15#16#17#17#17#18#19;
  PButton: String[length(CButton)] = CButton;
begin
  getpalette:= @PButton;
end;

procedure TButton.HandleEvent(var Event: TEvent);
var keycode:word;
    c:char;

  procedure ejected;
  var ev:TEvent;
  begin
    if commandenabled(command) then begin
      if flags and bfBroadCast>0 then
        message(owner, evBroadCast, command, @self)
      else begin
        ev.what:=evcommand;
        ev.command:=command;
        putevent(ev);
      end;
    end;
    clearevent(event);
  end;

begin
  TView.Handleevent(event);
  if event.what and positionalevents>0 then begin {Maus}
    if event.what and evMouseup>0 then
      ejected
    else if event.what and evMousedown>0 then begin
      if options and ofselectable>0 then focus;
      if correctViewPort then buttonDraw(false,false);
    end;
  end else if event.what and focusedevents>0 then begin {Tastatur}
    if (event.what=evcommand) and (event.command=cmdefault) and amdefault then
      ejected
    else if event.what=evkeydown then begin
      c:= Getselectchar(Title);
      if (Event.KeyCode = GetAltCode(C)) or
         ((Owner^.phase = phPostProcess) and (c<>#0) and
         (Upcase(Event.Charcode)=C)) or
         (amdefault and ((event.charcode=' ') or (event.charcode=#13))) then begin
        ejected;
        clearevent(event);
{      if event.charcode=#0 then keycode:=event.keycode
      else keycode:=getaltcode(event.charcode);
      if (upcase(getaltchar(keycode))=upcase(getselectchar(title))) then
      ejected;}
      end;
    end;
  end else begin  {evBroadCast}
    case event.command of
      cmgrabdefault:if event.infoptr<>@self then begin
        amdefault:=false;
        if correctviewport then Buttondraw(false,true);
      end;
      cmreceivedfocus:if event.infoptr<>@self then begin
        if correctviewport then Buttondraw(false,true);
      end;
      cmreleasedefault:if (flags and bfdefault>0) then begin
        amdefault:=true;
        if correctviewport then Buttondraw(false,true);
      end;
    end;
  end;
end;

procedure TButton.MakeDefault(Enable: Boolean);
begin
  if amdefault<>enable then begin
    amdefault:=enable;
    if enable then message(owner,evbroadcast,cmgrabDefault,@self)
    else message(owner,evBroadCast,cmreleasedefault,@self);
    DrawView;
  end;
end;

procedure TButton.Press; 
begin
  message(owner,evBroadCast,cmRecordHistory,@self);
end;

procedure TButton.SetState(AState: Word; Enable: Boolean); 
begin
  TView.Setstate(Astate,Enable);
  if Astate and (sfselected or sfActive)>0 then Tview.DrawView;
{  if (Astate and sfFocused)>0 then MakeDefault(enable);}
end;

constructor TCluster.Init(var Bounds: TRect; AStrings: PSItem);
var hstring:PSItem;
begin
  TView.Init(Bounds);
  strings.init(16,100);
  while AStrings<>nil do begin
    Strings.atinsert(strings.count,astrings^.value);
    Hstring:=AStrings;
    AStrings:=AStrings^.next;
    dispose(hstring);
  end;
  positionctx:=scHandclusterShape;
  options:=options or ofselectable;
end;

procedure TCluster.Store(var S:TStream);
begin
  TView.Store(s);
  s.write(value,sizeof(value));
  s.write(sel,sizeof(sel));
  strings.store(s);
end;

constructor TCluster.Load(var S: TStream);
begin
  TView.Load(s);
  s.read(value,sizeof(value));
  s.read(sel,sizeof(sel));
  strings.load(s);
end;

destructor TCluster.Done; 
begin
  strings.done;
  TView.done;
end;

function TCluster.DataSize: Word; 
begin
  datasize:=sizeof(value);
end;

procedure TCluster.DrawBox(eckig:boolean);
var z,n,zeilen:byte;
    r:TRect;
    xende,xpos,maxx,boxcolor,textcolor,schaltercolor:word;
    item:PString;
begin
  if getstate(sfvisible) then begin
    getextent(r);
    zeilen:=(r.b.y-r.a.y) div 12;
    boxcolor:=getcolor(8*256+7);
    feld(r.a.x,r.a.y,r.b.x,r.b.y,false,boxcolor);
    xpos:=10;
    n:=1;
    schaltercolor:=getcolor(5*256+6);
    while n<=strings.count do begin
      maxx:=10;
      for z:=0 to pred(zeilen) do if (n<=strings.count) then begin
        if eckig then schaltereckig(xpos,3+z*12,not mark(pred(n)),boxcolor,schaltercolor)
        else schalterrund(xpos,3+z*12,not mark(pred(n)),boxcolor,schaltercolor);
        if sel=pred(n) then textcolor:=getcolor(4*256+2)
        else textcolor:=getcolor(3*256+1);
        item:=strings.at(pred(n));
        xende:=xpos+16+CStrLen(item^)*8;
        schreibe(xpos+16,4+z*12,xende,16+z*12,false,item^,textcolor);
        if maxx<xende then maxx:=xende;
        inc(n);
      end;
      xpos:=10+maxx;
    end;
  end;
end;

procedure TCluster.ReDraw(nr:word;eckig:boolean);
var z,n,zeilen:byte;
    r:TRect;
    xende,xpos,maxx,boxcolor,textcolor,schaltercolor:word;
    item:PString;
begin
  if getstate(sfvisible) then begin
    getextent(r);
    zeilen:=(r.b.y-r.a.y) div 12;
    boxcolor:=getcolor(8*256+7);
    xpos:=10;
    n:=1;
    schaltercolor:=getcolor(5*256+6);
    while n<=strings.count do begin
      maxx:=10;
      for z:=0 to pred(zeilen) do if (n<=strings.count) then begin
        if (pred(n)=nr) then begin
          if eckig then schaltereckig(xpos,3+z*12,not mark(pred(n)),boxcolor,schaltercolor)
          else schalterrund(xpos,3+z*12,not mark(pred(n)),boxcolor,schaltercolor);
        end;
        item:=strings.at(pred(n));
        xende:=xpos+16+CStrLen(item^)*8;
        if (pred(n)=nr) then begin
          if sel=pred(n) then textcolor:=getcolor(4*256+2)
          else textcolor:=getcolor(3*256+1);
          schreibeneu(xpos+16,4+z*12,xende,16+z*12,false,item^,textcolor);
        end;
        if maxx<xende then maxx:=xende;
        inc(n);
      end;
      xpos:=10+maxx;
    end;
  end;
end;

function TCluster.GetPositionItem(where:TPoint):word; {liefert die nummer des angeklicketen Items 0..n}
var z,n,zeilen:byte;
    r:TRect;
    maxx:word;
    weiter:boolean;
begin
  makelocal(where,where);
  getextent(r);
  zeilen:=(r.b.y-r.a.y) div 12;
  r.a.x:=10;
  maxx:=10;
  n:=0;
  weiter:=true;
  GetpositionItem:=$FFFF;
  while (n<=pred(strings.count)) and weiter do begin
    for z:=0 to pred(zeilen) do if (n<=pred(strings.count)) and weiter then begin
      r.a.y:=3+z*12;
      r.b.x:=r.a.x+16+CStrLen(pstring(strings.at(n))^)*8;
      r.b.y:=12+r.a.y;
      if positionin(where,r) then begin
        weiter:=false;
        GetPositionItem:=n;
      end;
      if maxx<r.b.x then maxx:=r.b.x;
      inc(n);
    end;
    r.a.x:=10+maxx;
  end;
end;

function TCluster.HotKey(KeyCode: Word): word;
var c:char;
    n:word;
begin
  c:=upcase(getaltchar(keycode));
  n:=0;
  while (n<=pred(strings.count)) and
        (upcase(getselectchar(pstring(strings.at(n))))<>c) do inc(n);
  if (n<strings.count) and
     (upcase(getselectchar(pstring(strings.at(n))))=c)  then hotkey:=n
  else hotkey:=$FFFF;
end;

function TCluster.FindItem(Ch:Char): word;
begin
  Finditem:=hotkey(getaltcode(ch));
end;

function TCluster.Art:Boolean;
begin
  art:=true;
end;

procedure TCluster.setsel(neusel:word);
var h:integer;
begin
  h:=sel;
  sel:=neusel;
  press(neusel);
  if correctviewport then redraw(h,art);
end;

procedure TCluster.HandleEvent(var Event: TEvent);
var item:word;
begin
  TView.HandleEvent(event);
  if event.what and positionalevents>0 then begin
    if event.what and evmousedown >0 then begin
      item:=getpositionItem(event.where);
      if item<>$FFFF then begin
        setsel(item);
        clearevent(event);
      end;
    end;
  end else if event.what and focusedevents>0 then begin
    if event.what and evkeydown>0 then begin
      if selectpfad{getstate(sffocused)} or (event.charcode=#0) then begin
        if event.charcode=#0
        then Item:=HotKey(event.keycode)
        else Item:=FindItem(event.charcode);
        if item<>$FFFF then begin
          setsel(item);
          clearevent(event);
        end;
      end;
    end;
  end;
end;

procedure TCluster.GetData(var Rec); 
begin
  move(value,rec,sizeof(value));
end;

function TCluster.GetHelpCtx: Word; 
begin
  gethelpctx:=helpctx+sel;
end;

function TCluster.GetPalette: PPalette; 
const
  CCluster = #20#21#22#22#23#24#25#26;
  PCluster: String[length(CCluster)] = CCluster;
begin
  getpalette:= @PCluster;
end;

function TCluster.Mark(Item: Integer):Boolean; 
begin
  mark:=false;
end;

procedure TCluster.MovedTo(Item: Integer); 
begin
  abstract;
end;

procedure TCluster.Press(Item: Integer); 
begin
  abstract;
end;

procedure TCluster.SetData(var Rec); 
begin
  move(rec,value,sizeof(value));
  if CorrectViewPort then TView.DrawView;
end;

procedure TCluster.SetState(AState:Word; Enable: Boolean); 
begin
  TView.SetState(AState,Enable);
{  if (astate and sfselected>0) and correctViewPort then TView.DrawView;}
end;

procedure TCheckBoxes.Draw;{bis zu 16 Schalter gedrckt}
begin
  drawbox(true);
end;

function TCheckBoxes.Mark(Item: Integer): Boolean;{schalter nummer item (0..n) gedrckt ?}
begin
  mark:=value and (1 shl Item)>0;
end;

procedure TCheckBoxes.Press(Item: Integer);{schalter n (0..15) wurde gedrckt}
var bit:word;
begin
  bit:=1 shl item;
  if value and bit>0 then value:=value and (not bit)
  else value:=value or bit;
  if correctviewport then redraw(item,true);{schalter value eckig}
end;

procedure TRadioButtons.Draw;{nur einer von 256 Schaltern gedrckt}
begin
  drawbox(false);
end;

function TRadioButtons.Mark(Item: Integer): Boolean;
begin
  mark:=value=item;
end;

procedure TRadioButtons.MovedTo(Item: Integer);
begin
  value:=item;
end;

function TRadioButtons.Art:Boolean;
begin
  art:=false;
end;

procedure TRadioButtons.Press(Item: Integer);
begin
  if correctviewport then begin
    value:=item;
    redraw(item,false);{schalter value rund}
  end;
end;

procedure TRadioButtons.SetData(var Rec);
begin
  move(rec,value,sizeof(value));
  sel:=value;
  if CorrectViewPort then TView.DrawView;
end;


constructor TDialog.Init(var Bounds: TRect; ATitle: TTitleStr);
begin
  TWindow.Init(bounds,atitle,wnnonumber);
  growmode:=0;
  flags:=wfmove or wfclose;
  palette:=wpGrayWindow;
  options:=options or ofbuffered;
end;

procedure TDialog.HandleEvent(var Event:Tevent);

  procedure putcommand(cm:word);
  var ev:Tevent;
  begin
    ev.what:=evcommand;
    ev.command:=cm;
    putevent(ev);
    clearevent(event);
  end;

begin
  TWindow.Handleevent(event);
  if event.what=evkeydown then begin
    if event.keycode=kbESC then putcommand(cmcancel)
    else if event.keycode=kbENTER then putcommand(cmdefault);
  end else if event.what=evcommand then begin
    if (event.command<256) and (event.command in [cmok,cmyes,cmno]) then begin
      if getstate(sfmodal) then endmodal(event.command)
      else begin
        done;
        dispose(@self);
      end;
      clearevent(event);
    end;
  end;
end;

function TDialog.GetPalette: PPalette; 
const PDialog: String[length(CDialog)] = CDialog;
begin
  getpalette:= @PDialog;
end;

function TDialog.valid(command: Word): Boolean; 
begin
  if command=cmcancel then valid:=true else valid:=TGroup.Valid(command);
end;

constructor TInputLine.Init(var Bounds: TRect; AMaxLen: Integer);
begin
  TView.Init(Bounds);
  options:=options or ofSelectable or ofFirstClick;
  state:=state or sfCursorVis;
  if amaxlen<0 then amaxlen:=0;
  if amaxlen>255 then amaxlen:=255;
  getmem(data,succ(AMaxLen));
  data^:='';
  maxlen:=aMaxLen;
  CurPos:=1;
  Firstpos:=1;
  selStart:=0;
  selend:=0;
  positionctx:=scfedershape;
  dy:=(bounds.b.y-bounds.a.y-7) div 2;
end;

procedure TInputLine.Store(var S: TStream);
begin
  TView.Store(s);
  s.write(selend,sizeof(selend));
  s.write(selstart,sizeof(selstart));
  s.write(firstpos,sizeof(firstpos));
  s.write(CurPos,sizeof(CurPos));
  s.write(MaxLen,sizeof(MaxLen));
  s.writestr(data);
end;

constructor TInputLine.Load(var S: TStream);
var buf:Pstring;
    r:trect;
begin
  TView.Load(s);
  s.read(selend,sizeof(selend));
  s.read(selstart,sizeof(selstart));
  s.read(firstpos,sizeof(firstpos));
  s.read(CurPos,sizeof(CurPos));
  s.read(MaxLen,sizeof(MaxLen));
  getmem(data,succ(MaxLen));
  buf:=s.readstr;
  data^:=buf^;
  disposestr(buf);
  getextent(r);
  dy:=(r.b.y-r.a.y-7) div 2;
end;

destructor TInputLine.Done; 
begin
  freemem(data,succ(maxLen));
  TView.Done;
end;

function TInputLine.DataSize; 
begin
  datasize:=succ(maxlen);
end;

procedure TInputLine.GetData(var Rec);
begin
  move(data^[0],rec,succ(maxlen));
end;

procedure TInputLine.Draw;
var r:trect;
    n,lange,aktlange:byte;
    boxcolor,textcolor,markcolor,symbolcolor:word;
    text,mark:string;
    markiert,textsicht:boolean;
begin
  if getstate(sfvisible) then begin
    getextent(r);
    boxcolor:=getcolor(6*256+5);
    feld(r.a.x,r.a.y,r.b.x,r.b.y,false,boxcolor);
    if firstpos>0 then begin
      if getstate(sfactive) then textcolor:=getcolor(2)
      else textcolor:=getcolor(1);
      if insertmode then symbolcolor:=getcolor(7) else symbolcolor:=getcolor(8);
      textcolor:=textcolor or (symbolcolor*256);
      markcolor:=getcolor(3*256+3);
      symbolcolor:=getcolor(4);
      lange:=(r.b.x-r.a.x-20) div 8;
      aktlange:=length(data^);
      text:='';
      mark:='';
      n:=firstpos;
      markiert:=false;
      textsicht:=false;
      while (n<firstpos+lange) and (n<=aktlange) do begin
        if (n>=selstart) and (n<=selend) then begin
          markiert:=true;
          mark:=mark+data^[n];
          text:=text+' ';
        end else begin
          mark:=mark+' ';
          text:=text+data^[n];
          textsicht:=true;
        end;
        inc(n);
      end;
      if textsicht then schreibecursor(12+r.a.x,r.a.y+dy,succ(curpos-firstpos),text,textcolor);
      if markiert then schreibecursor(12+r.a.x,r.a.y+dy,succ(curpos-firstpos),mark,markcolor);
      if firstpos>1 then schreibe(r.a.x+2,r.a.y+dy,10+r.a.x,r.b.y,false,#17,symbolcolor);
      if n<aktlange then schreibe(r.b.x-10,r.a.y+dy,r.b.x-2,r.b.y,false,#16,symbolcolor);
    end;
  end;
end;

procedure TInputLine.HandleEvent(var Event: TEvent);
var myevent:boolean;

  procedure addbuchstabe(ch:char);
  var r:trect;
      curcolor,textcolor:word;
      lange:Integer;
  begin
    if correctViewport then begin
      if ch=#8 then begin
        if curpos>1 then begin
          getextent(r);
          lange:=(r.b.x-r.a.x-20) div 8;
          data^:=copy(data^,1,curpos-2)+copy(data^,curpos,length(data^)-pred(curpos));
          dec(curpos);
          if (curpos=succ(length(data^))) and (curpos>=firstpos) then begin
            loschezeichen(r.a.x+12+8*(curpos-firstpos),r.a.y+dy,2,getcolor(6*256+5));
            if insertmode then curcolor:=getcolor(7) else curcolor:=getcolor(8);
            schreibe(r.a.x+12+8*(curpos-firstpos),r.a.y+dy,r.a.x+12+8*succ(curpos-firstpos),r.a.y+12,false,'_',curcolor);
          end else begin
            if curpos<firstpos then firstpos:=curpos;
            drawview;
          end;
        end;
      end else if (length(data^)<maxlen) or ((not InsertMode) and (curpos<succ(length(data^)))) then begin
        getextent(r);
        lange:=(r.b.x-r.a.x-20) div 8;
        if InsertMode then data^:=copy(data^,1,pred(curpos))+ch+copy(data^,curpos,length(data^)-pred(curpos))
        else begin
          if curpos<=length(data^) then data^[curpos]:=ch else data^:=data^+ch;
        end;
        inc(curpos);
        if firstpos=0 then firstpos:=1;
        if (curpos>=firstpos+lange) or (curpos<>succ(length(data^))) then begin
          if (curpos>=firstpos+lange) then inc(firstpos);
          DrawView;
        end else begin
          if getstate(sfactive) then textcolor:=getcolor(2)
          else textcolor:=getcolor(1);
          if insertmode then textcolor:=textcolor or (getcolor(7)*256) else textcolor:=textcolor or (getcolor(7)*256);
          schreibecursorneu(4+r.a.x+(curpos-firstpos)*8,r.a.y+dy,ch,textcolor,getcolor(6*256+5));
        end;
      end;
    end;
  end;

  procedure delbuchstabe;
  begin
    if curpos<=length(data^) then begin
      data^:=copy(data^,1,curpos-1)+copy(data^,succ(curpos),length(data^)-pred(curpos));
      drawview;
    end;
  end;

  procedure shiftcursor(d:integer);
  var r:TRect;
      lange:Integer;
      oldcur:integer;
      curcolor,textcolor:word;
  begin
    if length(data^)>0 then begin
      getextent(r);
      lange:=(r.b.x-r.a.x-20) div 8;
      oldcur:=curpos;
      inc(curpos,d);
      if curpos<1 then curpos:=1 else
      if curpos>succ(length(data^)) then curpos:=succ(length(data^));
      if oldcur<>curpos then begin
        if (curpos<firstpos) or ((curpos>=firstpos+lange) and (d>0)) then begin
          if curpos<firstpos then firstpos:=curpos else
          if (curpos>=firstpos+lange) and (d>0) then firstpos:=succ(curpos-lange);
          DrawView;
        end else if correctviewport then begin
          if getstate(sfactive) then textcolor:=getcolor(2)
          else textcolor:=getcolor(1);
          if InsertMode then Curcolor:=getcolor(7) else Curcolor:=getcolor(8);
          if oldcur>length(data^)
          then loschezeichen(r.a.x+12+8*(oldcur-firstpos),r.a.y+dy,1,getcolor(6*256+5))
          else schreibechar(r.a.x+12+8*(oldcur-firstpos),r.a.y+dy,data^[oldcur],textcolor);
          if curpos>length(data^) then
          schreibechar(r.a.x+12+8*(curpos-firstpos),r.a.y+dy,'_',curcolor)
          else schreibechar(r.a.x+12+8*(curpos-firstpos),r.a.y+dy,data^[curpos],curcolor);
        end;
      end;
    end;
  end;

  procedure newcursor;
  var r:TRect;
      lange:Integer;
      curcolor,textcolor:word;
  begin
    getextent(r);
    lange:=(r.b.x-r.a.x-20) div 8;
    if InsertMode then Curcolor:=getcolor(7) else Curcolor:=getcolor(8);
    if correctviewport then begin
      if curpos>length(data^) then
      schreibechar(r.a.x+12+8*(curpos-firstpos),r.a.y+dy,'_',curcolor)
      else schreibechar(r.a.x+12+8*(curpos-firstpos),r.a.y+dy,data^[curpos],curcolor);
    end;
  end;

  procedure setend;
  var r:TRect;
      lange:Integer;
  begin
    getextent(r);
    lange:=(r.b.x-r.a.x-20) div 8;
    firstpos:=length(data^)-lange+2;
    if firstpos<1 then firstpos:=1;
    curpos:=succ(length(data^));
    drawView;
  end;

  procedure buchstabe;
  begin
    if selstart>0 then begin
      if event.charcode<>#8 then begin
        data^:=copy(data^,1,pred(selstart))+event.charcode+copy(data^,succ(selend),length(data^)-selend);
        curpos:=succ(selstart);
      end else begin
        data^:=copy(data^,1,pred(selstart))+copy(data^,succ(selend),length(data^)-selend);
        curpos:=selstart;
      end;
      if length(data^)>0 then firstpos:=1 else firstpos:=0;
      selend:=0;
      selstart:=0;
      DrawView;
    end else addbuchstabe(event.charcode);
    clearevent(event);
  end;

begin
  TView.HandleEvent(event);
  if event.what and focusedevents>0 then begin
    if event.what and evkeydown>0 then begin
      if (event.charcode<>#0) and (not (event.charcode in [#27,#13,#9])) then
        buchstabe
      else begin
        myevent:=true;
        case event.keycode of
        kbright:begin
          clearevent(event);
          if (selstart>0) then selectall(false);
          shiftcursor(1);
        end;
        kbleft:begin
          clearevent(event);
          if (selstart>0) then selectall(false);
          shiftcursor(-1);
        end;
        kbdel:begin
          clearevent(event);
          delbuchstabe;
        end;
        kbHome:begin
          clearevent(event);
          selectall(false);
        end;
        kbEnd:begin
          clearevent(event);
          SetEnd;
        end;
        kbIns:begin
          clearevent(event);
          newcursor;
        end;
        else myevent:=false;
        end;
        if myevent then clearevent(event);
      end;
    end;
  end else if event.what and positionalevents>0 then begin
    if event.what and evmousedown>0 then begin
    end else if event.what and evmouseup>0 then begin
    end;
  end else begin
  end;
end;

function TInputLine.GetPalette: PPalette; 
const
  CInputLine = #27#27#28#29#30#31#32#33;
  PInputLine: String[length(CInputLine)] = CInputLine;
begin
  getpalette:= @PInputLine;
end;

procedure TInputLine.SelectAll(Enable: Boolean);
begin
  if length(data^)>0 then firstpos:=1 else firstpos:=0;
  curpos:=1;
  if enable then begin
    selend:=length(data^);
    selstart:=firstpos;
  end else begin
    selend:=0;
    selstart:=0;
  end;
  DrawView;
end;

procedure TInputLine.SetData(var Rec); 
begin
  move(rec,data^[0],succ(maxlen));
  selectall(true);
end;

procedure TInputLine.SetState(AState: Word; Enable: Boolean); 
begin
  TView.SetState(astate,enable);
  if astate and (sfactive or sfselected) >0 then SelectAll(Enable);
end;

constructor TStaticText.Init(var Bounds: TREct; ATExt: String);
begin
  TView.Init(Bounds);
  text:=newstr(AText);
end;

procedure TStaticText.Store(var S: TStream);
begin
  TView.store(s);
  s.writestr(text);
end;

constructor TStaticText.Load(var S: TStream);
begin
  TView.load(s);
  text:=s.readstr;
end;

destructor TStaticText.Done; 
begin
  disposestr(text);
  tview.done;
end;

procedure TStaticText.Draw;
var r:trect;
    tex,buf:string;
    n:byte;
    maxlen:integer;
    ypos,textcolor:word;
    zentriert:boolean;
begin
  if getstate(sfvisible) then begin
    gettext(tex);
    getextent(r);
    zentriert:=tex[1]=#3;
    if zentriert then n:=2 else n:=1;
    ypos:=0;
    maxlen:=((r.b.x-r.a.x) div 8);
    if maxlen>255 then maxlen:=255 else if maxlen<0 then maxlen:=0;
    textcolor:=getfarbe;
    repeat
      buf:='';
      while (n<=Length(tex)) and (tex[n]<>#13) do begin
        buf:=buf+tex[n];
        inc(n);
      end;
      while CStrLen(buf)>maxlen do delete(buf,length(buf),1);
      if TypeOf(self)=TypeOf(TParamText) then loschezeichen(r.a.x,r.a.y+ypos,CStrLen(buf),textcolor);
      schreibe(r.a.x,r.a.y+ypos,r.b.x,r.a.y+ypos+10,zentriert,buf,textcolor);
      while (tex[n]=#13) and (n<Length(tex)) do begin
        inc(ypos,10);
        inc(n);
      end;
    until n>CStrLen(tex);
  end;
end;

function TStaticText.GetPalette: PPalette; 
const
  CStaticText = #9#4;
  PStaticText: String[length(CStaticText)] = CStaticText;
begin
  getpalette:= @PStaticText;
end;

procedure TStaticText.GetText(var S: String); 
begin
  s:=text^;
end;

function TStaticText.getfarbe:word;
begin
  getfarbe:=getcolor(2*256+1);
end;

constructor TLabel.Init(var Bounds: TRect; AText: String; ALink: PView);
begin
  TStaticText.init(bounds,atext);
  options:=options or ofpreprocess or ofpostprocess;
  eventmask:=eventmask or evbroadcast;
  link:=alink;
  light:=false;
end;

procedure TLabel.Store(var S:TStream); 
begin
  TStaticText.store(s);
  putpeerviewptr(s,link);
end;

constructor TLabel.Load(var S: TStream);
begin
  TStaticText.load(s);
  getpeerviewptr(s,link);
  light:=false;
end;

function TLabel.getfarbe:word;
begin
  if light then getfarbe:=getcolor(4*256+2) else getfarbe:=getcolor(3*256+1);
end;

function TLabel.GetPalette: PPAlette;
const
  CLabel = #10#11#12#12;
  PLabel: String[length(CLabel)] = CLabel;
begin
  getpalette:= @PLabel;
end;

procedure TLabel.HandleEvent(var Event: TEvent);

  procedure setlight(alight:boolean);
  begin
    light:=alight;
    if correctviewport then draw;
    clearevent(event);
  end;

  procedure activate;
  begin
    setlight(true);
    if link<>nil then link^.focus;
  end;

begin
  TView.HandleEvent(event);
  if (event.what and positionalevents)>0 then begin
    if event.what=evmousedown then activate;
  end else if event.what and focusedevents>0 then begin
    if (event.what=evkeydown) and (event.charcode=#0) and
       (upcase(getaltchar(event.keycode))=upcase(getselectchar(text))) then
     activate;
  end else begin
    if (event.what=evbroadcast) and (event.infoptr=link) then begin
      if event.command=cmreleasedfocus then setlight(false)
      else if event.command=cmReceivedFocus then setlight(true);
    end;
  end;
end;

constructor TListBox.Init(var Bounds: TRect; ANumCols: Word; AScrollBar: PScrollBar);
begin
  TListViewer.Init(Bounds,ANumCols,nil,AScrollBar);
  list:=nil;
end;

procedure TListBox.Store(var S: TStream);
begin
  TListViewer.Store(s);
  list^.store(s);
end;

constructor TListBox.Load(var S: TStream);
begin
  TListViewer.Load(s);
  new(list,init(100,1000));
  list^.load(s);
end;

function TListBox.DataSize: Word; 
begin
  DataSize:=sizeof(TListBoxRec);
end;

procedure TListBox.GetData(var Rec);
var ListBoxRec:TListBoxRec;
begin
  ListBoxRec.List:=list;
  ListBoxRec.Focused:=focused;
  move(Listboxrec,rec,sizeof(listboxrec));
end;

function TListBox.GetText(Item: Integer; MaxLen: Integer): String;
begin
  if (list=nil) or (item>=List^.count) then Gettext:='' else gettext:=copy(PString(List^.at(Item))^,1,MaxLen);
end;

procedure TListBox.NewList(AList: PCollection); 
begin
  if alist<>nil then begin
    if list<>nil then list^.done;
    list:=alist;
    Focused:=0;TopItem:=0;
    setrange(alist^.count);
    DrawView;
  end;
end;

procedure TListBox.SetData(var Rec); 
var ListBoxRec:TListBoxRec;
begin
  move(rec,Listboxrec,sizeof(listboxrec));
  if ListBoxRec.List<>nil then begin
    if list<>nil then list^.done;
    list:=ListBoxRec.List;
    setrange(list^.count);
    focusItem(ListBoxRec.Focused);
    DrawView;
  end;
end;

constructor TParamText.Init(var Bounds: TRect; AText: String; AParamCount: Integer);
begin
  TStaticText.Init(bounds,atext);
  paramcount:=aparamcount;
  paramlist:=nil;
end;

procedure TParamText.Store(var S: TStream);
begin
  TStaticText.store(s);
  s.write(paramcount,sizeof(paramcount));
end;

constructor TParamText.Load(var S: TStream);
begin
  TStaticText.load(s);
  s.read(paramcount,sizeof(paramcount));
  paramlist:=nil;
end;

function TParamText.DataSize: Word; 
begin
  datasize:=sizeof(longint)*paramcount;
end;

procedure TParamText.GetText(var S: String);
begin
  Drivers.formatstr(s,text^,paramlist^);
end;

procedure TParamText.SetData(var Rec);
begin
  paramlist:=@rec;
end;

const HandButtonShape:TShape = (relx:11;rely:0;
      shape : (screen : ($FFFF,$FFEF,$FFC7,$FFC7,
                         $FFC7,$FFC7,$FFC7,$F547,
                         $E007,$E003,$E003,$E003,
                         $E007,$F00F,$F00F,$F03F);
               mask   : ($0000,$0000,$0010,$0010,
                         $0010,$0010,$0010,$0010,
                         $0AB0,$0AB0,$0FE8,$0D78,
                         $0D70,$0560,$07C0,$0000));
          number:scHandButtonShape);

const HandClusterShape:TShape = (relx:0;rely:4;
      shape : (screen : ($FFFF,$FFFF,$FF8F,$C007,
                         $8001,$C001,$FF00,$FE00,
                         $FF00,$FE00,$FF00,$FE00,
                         $FF07,$FFFF,$FFFF,$FFFF);
               mask   : ($0000,$0000,$0000,$0030,
                         $3FD8,$00FC,$003E,$00E2,
                         $003E,$00E2,$003E,$00F8,
                         $0000,$0000,$0000,$0000));
          number:scHandClusterShape);

const FederShape:TShape = (relx:0;rely:15;
      shape : (screen : ($FFC0,$FFC0,$FF8B,$FF97,
                         $FF0F,$FE0F,$FC1F,$FC1F,
                         $F83F,$F83F,$F07F,$F0FF,
                         $E0FF,$C3FF,$C7FF,$1FFF);
               mask   : ($0021,$0023,$0074,$0068,
                         $00F0,$01D0,$03A0,$03E0,
                         $0740,$06C0,$0D80,$0F00,
                         $1600,$0000,$0000,$0000));
          number:scfederShape);

begin
  MouseCursor^.RegisterShape(@handbuttonShape);
  MouseCursor^.RegisterShape(@handclusterShape);
  MouseCursor^.RegisterShape(@federShape);
end.
