unit TGMenus;
interface
uses Graph,Objects,Drivers,TGDriver,TGViews,TGMouse;
const cmSelectLast=99;
Type PMenu = ^TMenu;
     PMenuItem = ^TMenuItem;
     TMenu = record
       Items: PMenuItem;
       Default: PMenuItem;
     end;

     TMenuItem = record
       Next: PMenuItem;
       Name: PString;
       Command: Word;
       Disabled: Boolean;
       KeyCode: Word;
       HelpCtx: Word;
       case Integer of
         0: (Param: PString);
         1: (SubMenu: PMenu);
     end;

     TMenuStr = string[31];

     PStatusDef = ^TStatusDef;
     PStatusItem = ^TStatusItem;
     TStatusDef = record
       Next: PStatusDef;
       Min, Max: Word;
       Items: PStatusItem;
     end;
     
     TStatusItem = record
       Next: PStatusItem;
       Text: PString;
       KeyCode: Word;
       Command: Word;
     end;

     PMenuView = ^TMenuView;
     TMenuView = object(TView)
       ParentMenu: PMenuView;
       Menu: PMEnu;
       Current: PMenuItem;
       constructor Init(var Bounds: TRect);
       constructor Load(var S: TStream);
       function Execute: Word; virtual;
       function FindItem(Ch:Char): PMenuItem;
       procedure GetItemRect(Item: PMenuItem; var R: TRect); virtual;
       function GetHlpCtx: Word; virtual;
       function GetPalette: PPalette; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       function HotKey(KeyCode: Word): PMenuItem;
       procedure Store(var S: TStream);
       function findPositionItem(where:TPoint):PMenuItem;
       procedure setcurrent(NewCurrent: PMenuItem); virtual;
       procedure execsubmenu(var aktmenuItem:PMenuItem); virtual;
       function exmenu(nmenu:Pmenu;ncurrent:PMenuItem):boolean;
     end;

     PMenuBar = ^TMenuBar;
     TMenuBar = object(TMenuView)
       OldFocused:PView;
       constructor Init(var Bounds: TRect; AMenu: PMenu);
       constructor Load(var S: TStream);
       destructor done; virtual;
       procedure Draw; virtual;
       procedure GetItemRect(Item: PMenuItem; var R: TRect); virtual;
       procedure setcurrent(NewCurrent: PMenuItem); virtual;
       procedure execsubmenu(var aktmenuItem:PMenuItem); virtual;
     end;

     PMenuBox = ^TMenuBox;
     TMenuBox = object(TMenuView)
       buffer:pointer;
       constructor Init(var Bounds: TRect; AMenu: PMenu; AParentMenu: PMenuView);
       procedure Draw; virtual;
       procedure GetItemRect(Item: PMenuItem; var R: TRect); virtual;
       procedure setcurrent(NewCurrent: PMenuItem); virtual;
     end;

     PStatusLine = ^TStatusLine;
     TStatusLine = object(TView)
       Items,Current: PStatusItem;
       Defs: PStatusDef;
       constructor Init(var Bounds: TRect; ADefs: PStatusDef);
       constructor Load(var S: TStream);
       destructor Done; virtual;
       procedure Draw; virtual;
       function GetPalette: PPalette; virtual;
       procedure HandleEvent(var Event: TEvent); virtual;
       function Hint(AHelpCtx: Word):String; virtual;
       procedure Store(var S: TStream);
       procedure Update(ctx:word);
       procedure setcurrent(NewCurrent: PStatusItem);
       procedure GetItemRect(aktitem:PStatusItem;var r:TRect);
     end;

procedure DisposeMenu(Menu: PMenu);
function NewMenu(Items: PMenuItem):Pmenu;
function NewItem(AName, AParam: TMenuStr; AKeyCode: Word; ACommand: Word; AHelpCtx: Word; ANext: PMenuItem): PMenuItem;
function NewSubMenu(AName: TMenuStr; AHelpCtx: Word; ASubMenu: PMenu; ANext: PMenuItem):PMenuItem;
function NewLine(Next: PMenuItem):PMenuItem;
function NewStatusDef(AMin, AMax: Word; AItems: PStatusItem; ANext: PStatusDef):PStatusDef;
function NewStatusKey(AText: String; AKeyCode: Word; ACommand: Word; ANext: PStatusItem): PStatusItem;
procedure RegisterMenus;
procedure clearrec(var r:trect);

implementation
const ScSenkrechtShape=1;
      scNachUntenShape=2;
      scNachRechtsShape=3;

procedure clearrec(var r:trect);
begin
  fillchar(r,sizeof(r),#0);
end;

procedure DisposeMenu(Menu: PMenu);

  procedure DisposeSubMenu(Item: PMenuItem);
  begin
    if Item^.next<>nil then disposeSubMenu(Item^.next);
    disposestr(Item^.name);
    if (Item^.command=0) and (Item^.submenu<>nil)
    then disposeMenu(Item^.SubMenu)
    else DisposeStr(Item^.param);
    dispose(item);
  end;

begin
  if Menu^.Items<>nil then DisposeSubMenu(Menu^.Items);
  dispose(menu);
end;

function NewItem(AName, AParam: TMenuStr; AKeyCode: Word; ACommand: Word; AHelpCtx: Word; ANext: PMenuItem): PMenuItem;
var MenuItem:PMenuItem;
begin
  new(menuItem);
  with MenuItem^ do begin
    Name:=Newstr(AName);
    HelpCtx:=AHelpCtx;
    Param:=newstr(Aparam);
    Next:=ANext;
    KeyCode:=AKeyCode;
    Command:=ACommand;
  end;
  NewItem:=MenuItem;
end;

function NewLine(Next: PMenuItem):PMenuItem;
var MenuItem:PMenuItem;
begin
  new(MenuItem);
  MenuItem^.next:=next;
  MenuItem^.name:=nil;
  MenuItem^.command:=1;
  MenuItem^.param:=nil;
  MenuItem^.HelpCtx:=hcnocontext;
  NewLine:=MenuItem;
end;

function NewMenu(Items: PMenuItem):Pmenu;
var Menu:PMenu;
begin
  new(menu);
  menu^.Items:=Items;
  menu^.Default:=Items;
  newMenu:=menu;
end;

function NewStatusDef(AMin, AMax: Word; AItems: PStatusItem; ANext: PStatusDef):PStatusDef;
var StatusDef:PstatusDef;
begin
  new(statusdef);
  with statusdef^ do begin
    Min:=AMin;
    Max:=AMax;
    Items:=AItems;
    Next:=ANext;
  end;
  newstatusdef:=StatusDef;
end;

function NewStatusKey(AText: String; AKeyCode: Word; ACommand: Word; ANext: PStatusItem): PStatusItem;
var StatusItem:PStatusItem;
begin
  new(StatusItem);
  with StatusItem^ do begin
    Text:=newstr(AText);
    KeyCode:=AKeyCode;
    Command:=ACommand;
    Next:=ANext;
  end;
  newStatusKey:=StatusItem;
end;

function NewSubMenu(AName: TMenuStr; AHelpCtx: Word; ASubMenu: PMenu; ANext: PMenuItem):PMenuItem;
var MenuItem:PMenuItem;
begin
  new(menuItem);
  with MenuItem^ do begin
    Name:=newstr(AName);
    HelpCtx:=AHelpCtx;
    SubMenu:=ASubMenu;
    Next:=ANext;
    Command:=0;
  end;
  NewSubMenu:=MenuItem;
end;

procedure RegisterMenus;
const RMenuBar:TStreamRec = (
        ObjType:140;
        VmtLink: Ofs(TypeOf(TMenuBar)^);
        Load: @TMenuBar.Load;
        Store: @TMenuBar.Store);
      RMenuBox:TStreamRec = (
        ObjType:141;
        VmtLink: Ofs(TypeOf(TMenuBox)^);
        Load: @TMenuBox.Load;
        Store: @TMenuBox.Store);
      RStatusLine:TStreamRec = (
        ObjType:142;
        VmtLink: Ofs(TypeOf(TStatusLine)^);
        Load: @TStatusLine.Load;
        Store: @TStatusLine.Store);
begin
  RegisterType(RMenuBar);
  RegisterType(RMenuBox);
  RegisterType(RStatusLine);
end;

constructor TMenuView.Init(var Bounds: TRect);
begin
  Tview.Init(Bounds);
  eventMask:=evBroadcast + evMouse + evKeyDown;
  ParentMenu:=nil;{kann auch weggelassen werden}
  options:=options or ofselectable;
  Menu:=nil;
  current:=nil;
end;

constructor TMenuView.Load(var S: TStream);
begin
  TView.Load(s);
end;

function TMenuView.Execute: Word;
var e: TEvent; 
begin
  if menu<>nil then begin
         
    repeat
      endstate:=0;
      repeat
        getevent(e);
        handleevent(e);
  {      if (e.what <> evNothing) and (owner<>nil) then owner^.EventError(E);}
      until EndState <> 0
    until Valid(EndState);
    Execute := EndState;
  end else execute:=cmCancel;
end;

function TMenuView.FindItem(Ch:Char): PMenuItem;
begin
  Finditem:=hotkey(getaltcode(ch));
end;

procedure TMenuView.GetItemRect(Item: PMenuItem; var R: TRect); 
begin
  abstract;
end;

function TMenuView.GetHlpCtx: Word;
begin
  if current=nil then begin
    if parentmenu=nil then Gethlpctx:=hcNoContext else GetHlpCtx:=ParentMenu^.GetHlpCtx;
  end else begin
    if current^.HelpCtx=hcNoContext then begin
      if parentmenu=nil then Gethlpctx:=hcNoContext else GetHlpCtx:=ParentMenu^.GetHlpCtx;
    end else getHlpCtx:=Current^.HelpCtx;
  end;
end;

function TMenuView.GetPalette: PPalette;
const
  CMenuView = #2#3#4#5#6#7#1#78;
  PMenuView: String[length(CMenuView)] = CMenuView;
begin
  getpalette:= @PMenuView;
end;

function TMenuView.findPositionItem(where:TPoint):PMenuItem;
var hmenu,oldmenu:PMenuItem;
    nichtgefunden:boolean;
    r:trect;
begin
  if menu<>nil then begin
    hmenu:=menu^.items;
    nichtgefunden:=true;
    oldmenu:=nil;
    makelocal(where,where);
    while (hmenu<>nil) and nichtgefunden do begin
      getitemrect(hmenu,r);
      nichtgefunden:=(r.a.x>where.x) or (r.a.y>where.y) or
                     (r.b.x<where.x) or (r.b.y<where.y);
      oldmenu:=hmenu;
      hmenu:=hmenu^.next;
    end;
    if nichtgefunden then findPositionItem:=nil else findPositionItem:=oldmenu;
  end else findpositionitem:=nil;
end;

var Tiefezuruck:byte;

function TMenuView.exmenu(nmenu:Pmenu;ncurrent:PMenuItem):boolean;
var neumenu:PMenuBox;
    bounds,r:TRect;
    ende:word;
begin
  exmenu:=false;
  getItemRect(ncurrent,bounds);{hole die lokalen koordinaten des aktuellen submenuseintrags}
  GetBounds(r); {Ausdehnung der MenuBox}
  if bounds.a.y<>0 then begin
    bounds.a.x:=succ(r.b.x); {wenn unteruntermenu dann linken rand auf rechten rand der aktuellen option}
    inc(bounds.a.y,r.a.y);
  end else inc(bounds.a.y,13); {13 runter, da menubox unter Menubar}
  new(neumenu,init(bounds,nmenu,@self));
  owner^.insert(neumenu);
  ende:=neumenu^.owner^.execview(neumenu);
  owner^.delete(neumenu);
  dispose(neumenu,done);
  case ende of
   cmcancel:endmodal(cmcancel);
   cmSelectLast:begin
     dec(Tiefezuruck);
     if Tiefezuruck=0 then exmenu:=true else endmodal(cmSelectLast);
   end;
  end;
end;

procedure TMenuView.execsubmenu(var aktmenuItem:PMenuItem);
var nichtende:boolean;
begin
  nichtende:=true;
  while nichtende do begin
    nichtende:=exmenu(current^.submenu,current);
    aktmenuitem:=findpositionItem(mousewhere);
    setcurrent(aktmenuitem);
    if (current^.command<>0) or (current^.name=nil) then begin
      nichtende:=false;
      focus;
    end;
  end;
end;

procedure TMenuView.HandleEvent(var Event: TEvent);
var AktMenuItem:PMenuItem;
    HParent,oldparent:PMenuView;
    ev:Tevent;
    woanders:boolean;
    command:word;

  function suchecommand(menu:PMenu):word;
  var hItem:PMenuItem;
      command:word;
  begin
    hItem:=menu^.items;
    command:=0;
    while (hitem<>nil) and (command=0) do begin
      if HItem^.command=0 then command:=suchecommand(HItem^.Submenu)
      else if (HItem^.name<>nil) and (HItem^.Keycode=event.keycode) then command:=Hitem^.command;
      hitem:=hitem^.Next;
    end;
    suchecommand:=command;
  end;

begin
  if event.what and positionalevents>0 then begin  {Mausereignis}
    if event.what and evmousemove>0 then begin   {Mausbewegt}
      if getstate(sffocused) then begin
        AktMenuItem:=findPositionItem(event.where);
        if aktmenuItem=nil then begin              {nicht im Bereich des aktuellen Menus}
          Hparent:=parentmenu;
          oldparent:=nil;
          tiefezuruck:=0;
          while (hparent<>nil) and (aktmenuitem=nil) do begin
            inc(tiefezuruck);
            aktmenuItem:=hparent^.findpositionitem(event.where);
            oldparent:=hparent;
            hparent:=hparent^.parentmenu;
          end;
          if aktMenuItem<>nil then begin
            if oldparent^.current<>aktmenuItem then endmodal(cmSelectLast);
          end else setcurrent(nil);
        end else begin                             {Mausbewegt in diesem Menu}
          if current<>aktMenuItem then begin  {Maus nicht auf aktuellem Menueintrag}
            setcurrent(aktmenuItem);
            if current^.command=0 then execSubMenu(aktmenuItem); {Neues Menu aufschlagen}
          end;
        end;
        clearevent(event);
      end;
    end else if event.what and evmousedown>0 then begin  {Maustastegedrckt}
      if getstate(sffocused) then begin
        HParent:=@self;
        woanders:=true;
        while (HParent<>nil) and woanders do begin
          woanders:=HParent^.findpositionItem(event.where)=nil;
          HParent:=HParent^.parentmenu;
        end;
        if woanders then endmodal(cmcancel);    {Mausclick auerhalb des Menubaums => cmCancel}
      end else begin
        aktmenuitem:=findpositionItem(event.where);
        if aktmenuitem<>nil then begin              {Mausclick auf MenuBar}
          clearevent(event);
          setcurrent(aktmenuitem);
          if current^.command=0 then begin
            execSubMenu(aktMenuItem);
          end else begin {Eintrag angeklickt, der in der MenuZeile steht und kein Submenu hat}
            if (current^.name<>nil) and commandenabled(current^.command) then begin
              ev.what:=evcommand;
              ev.command:=current^.command;
              putevent(ev);
            end;
          end;
        end;
      end;
    end else if (event.what and evmouseup)>0 then begin   {Maustastelosgelassen}
      if getstate(sffocused) then begin
        AktMenuItem:=findPositionItem(event.where);
        if aktmenuItem=nil then               {nicht im Bereich des aktuellen Menus}
          endmodal(cmcancel)
        else begin         {Maus losgelassen in diesem Menu auf aktuellem Meneintrag, der kein Submenu ist}
          if (current^.name<>nil) and commandenabled(current^.command) then begin
            ev.what:=evcommand;
            ev.command:=current^.command;
            putevent(ev);
          end;
          clearevent(event);
          endmodal(cmcancel);
        end;
        setcurrent(nil);
      end;
    end; {evmouseauto}
  end else if event.what and focusedevents>0 then begin {Tastaturereignis oder Kommando}
    if event.what and evkeydown>0 then begin
      if getstate(sffocused) or (event.charcode=#0) then begin
        if event.charcode=#0
        then AktMenuItem:=HotKey(event.keycode)
        else AktMenuItem:=FindItem(event.charcode);
        if aktmenuItem<>nil then begin
          if current<>aktMenuItem then begin  {nicht auf aktuellem Menueintrag}
            setcurrent(aktmenuItem);
            if current^.command=0 then execSubMenu(aktMenuItem)  {Neues Menu aufschlagen}
            else if commandenabled(current^.command) then begin
              ev.what:=evcommand;
              ev.command:=current^.command;
              putevent(ev);
              endmodal(cmcancel);
              setcurrent(nil);
            end;
          end;
          clearevent(event);
        end else begin
          Hparent:=parentmenu;
          oldparent:=nil;
          tiefezuruck:=0;
          while (hparent<>nil) and (aktmenuitem=nil) do begin
            inc(tiefezuruck);
            aktmenuItem:=hparent^.finditem(event.charcode);
            oldparent:=hparent;
            hparent:=hparent^.parentmenu;
          end;
          if aktMenuItem<>nil then begin
            if oldparent^.current<>aktmenuItem then endmodal(cmSelectLast);
          end else setcurrent(nil);
        end;
      end;
      if (event.what and evkeydown>0) and (TypeOf(self)=TypeOf(TMenuBar))
      then begin
        command:=suchecommand(menu);
        if command<>cmValid then begin
          clearevent(event);
          ev.what:=evcommand;
          ev.command:=command;
          putevent(ev);
        end;
      end;
    end else begin
      if (event.command=cmMenu) and (current=nil) then begin
        clearevent(event);
        setcurrent(Menu^.Items);
        if current^.command=0 then execSubMenu(aktMenuItem);
      end;
    end;
  end else begin  {evBroadcast}

  end;
end;

function TMenuView.HotKey(KeyCode: Word): PMenuItem;
var HMenu:PMenuItem;
    c:char;
begin
  if menu<>nil then begin
    HMenu:=menu^.items;
    c:=upcase(getaltchar(keycode));
    while (hmenu<>nil) and ((hmenu^.name=nil) or
      (upcase(getselectchar(hmenu^.name))<>c)) do hmenu:=hmenu^.next;
    hotkey:=hmenu;
  end else hotkey:=nil;
end;

procedure TMenuView.Store(var S: TStream);
begin
  TView.Store(s);
end;

procedure TMenuView.setcurrent(NewCurrent: PMenuItem);
begin
end;

constructor TMenuBar.Init(var Bounds: TRect; AMenu: PMenu);
begin
  TMenuView.Init(Bounds);
  options:=options or ofpreprocess;
  growmode:=gfgrowhix;
  menu:=amenu;
{  if menu<>nil then current:=Menu^.default;}
  current:=nil;
  OldFocused:=nil;
  positionCtx:=scsenkrechtshape;
end;

procedure TMenuBar.execsubmenu(var aktMenuItem:PMenuItem);
begin
  OldFocused:=Owner^.GetFocused;
  TMenuView.ExecsubMenu(aktMenuItem);
  if OldFocused<>nil then OldFocused^.Focus;
  oldfocused:=nil;
end;

destructor TMenuBar.done;
begin
  Tview.Done;
  DisposeMenu(Menu);
end;

constructor TMenuBar.Load(var s:TStream);
begin
  TMenuView.Load(s);
  OldFocused:=nil;
end;

procedure TMenuBar.Draw;
var xpos:word;
    hmenu:PMenuItem;
    textcolor,boxcolor:word;
begin
  xpos:=0;
  boxcolor:=getcolor(7*256+8); {Hintergrund und Rand}
  hidemouse;
  if menu<>nil then begin
    hmenu:=menu^.items;
    while hmenu<>nil do begin
      if hmenu^.name<>nil then begin
        if (hmenu^.command=0) or commandenabled(hmenu^.command) then begin {SubMenu oder Kommando erlaubt}
          if current=Hmenu then textcolor:=getcolor(6*256+4) else  {aktiviert}
          textcolor:=getcolor(3*256+1) {Normal}
        end else if current=Hmenu then textcolor:=getcolor(3*256+5) {selektiert aber nicht aktivierbar}
        else textcolor:=getcolor(3*256+2); {nicht aktivierbar}
        schreibefeld(xpos,0,xpos+16+8*length(hmenu^.name^),12,current<>hmenu,true,hmenu^.name^,textcolor,boxcolor);
        xpos:=succ(xpos+16+8*length(hmenu^.name^));
      end;
      hmenu:=hmenu^.next;
    end;
  end;
  feld(xpos,0,pred(screenwidth),12,true,boxcolor);
  showmouse;
end;

procedure TMenuBar.setcurrent(NewCurrent: PMenuItem);
var R:TRect;
    textcolor,boxcolor:word;
begin
  CorrectViewPort;
  boxcolor:=getcolor(7*256+8); {Hintergrund und Rand}
  if (current<>nil) and (current^.name<>nil) then begin
    GetItemRect(current,R);
    if (current^.command=0) or commandenabled(current^.command)
    then textcolor:=getcolor(3*256+1) {Normal}
    else textcolor:=getcolor(3*256+2); {nicht aktivierbar}
    Schreiberamen(r.a.x,r.a.y,r.b.x,r.b.y,true,true,current^.name^,textcolor,boxcolor);
  end;
  current:=newcurrent;
  if (current<>nil) and (current^.name<>nil) then begin
    GetItemRect(current,R);
    if (current^.command=0) or commandenabled(newcurrent^.command)
    then textcolor:=getcolor(6*256+4) {aktiviert}
    else textcolor:=getcolor(3*256+5); {selektiert aber nicht aktivierbar}
    Schreiberamen(r.a.x,r.a.y,r.b.x,r.b.y,false,true,current^.name^,textcolor,boxcolor);
  end;
end;

procedure TMenuBar.GetItemRect(Item: PMenuItem; var R: TRect); 
var xpos:word;
    hmenu:PMenuItem;
begin
  if menu<>nil then begin
    xpos:=0;
    hmenu:=menu^.items;
    while (hmenu<>nil) and (hmenu<>item) do begin
      if hmenu^.name<>nil then xpos:=succ(xpos+16+8*length(hmenu^.name^));
      hmenu:=hmenu^.next;
    end;
    r.a.x:=xpos;
    r.a.y:=0;
    if (hmenu^.name<>nil) and (hmenu<>nil) then r.b.x:=xpos+16+8*length(hmenu^.name^) else r.b.x:=xpos;
    r.b.y:=12;
  end else clearrec(r);
end;

constructor TMenuBox.Init(var Bounds: TRect; AMenu: PMenu; AParentMenu: PMenuView);
var eintragzahl,eintragbreite,aktstrlen:byte;
    Hmenu:PMenuItem;
begin
  eintragzahl:=0;
  eintragbreite:=0;
  if Amenu<>nil then begin
    current:=AMenu^.default;
    Hmenu:=AMenu^.Items;
    while hmenu<>nil do begin
      if hmenu^.name<>nil then begin
        aktstrlen:=cstrlen(hmenu^.name^);
        if hmenu^.param<>nil then inc(aktstrlen,2+length(hmenu^.param^));
        if aktstrlen>eintragbreite then eintragbreite:=aktstrlen;
      end;
      inc(eintragzahl);
      hmenu:=hmenu^.next;
    end;
  end;
  bounds.b.x:=bounds.a.x+20+8*eintragbreite;
  bounds.b.y:=bounds.a.y+9+13*eintragzahl;
  if bounds.b.x>=screenwidth then begin
    bounds.move(pred(screenwidth-bounds.b.x),0);
    if bounds.a.x<0 then bounds.a.x:=0;
  end;
  TMenuView.Init(Bounds);
  options:=options or ofpreprocess;
  menu:=AMenu;
{  state:=ofShadow;}
  parentMenu:=AParentMenu;
  positionctx:=scnachrechtsshape;
  buffer:=nil;
end;

  function gettext(hmenu:PMenuItem;zeichen:byte):string;
  var text:string;
      n:byte;
  begin
    text:=hmenu^.name^;
    if hmenu^.param<>nil then begin
      for n:=1 to zeichen-cstrlen(hmenu^.name^)-length(hmenu^.param^) do text:=text+' ';
      text:=text+hmenu^.param^;
    end;
    gettext:=text;
  end;

procedure TMenuBox.Draw;
var r:trect;
    hmenu:PMenuItem;
    ypos:word;
    text:string;
    zeichen,n:byte;
    textcolor,boxcolor:word;
begin
  getextent(r);
  hidemouse;
  if getstate(sfvisible) then begin
    boxcolor:=getcolor(7*256+8); {Hintergrund und Rand}
    if (buffer=nil) and (maxavail>imagesize(r.a.x,r.a.y,r.b.x,r.b.y)) then begin
      getmem(buffer,imagesize(r.a.x,r.a.y,r.b.x,r.b.y));
      getimage(r.a.x,r.a.y,r.b.x,r.b.y,buffer^);
    end;
    fenster(r.a.x,r.a.y,r.b.x,r.b.y,3,3,3,3,boxcolor);
    zeichen:=(r.b.x-r.a.x-20) div 8;
    ypos:=r.a.y+5;
    if menu<>nil then begin
      Hmenu:=Menu^.Items;
      while HMenu<>nil do begin
        if HMenu^.name<>nil then begin
          text:=gettext(hmenu,zeichen);
          if (hmenu^.command=0) or commandenabled(hmenu^.command) then begin
            if current=Hmenu then textcolor:=getcolor(6*256+4) else  {aktiviert}
            textcolor:=getcolor(3*256+1) {Normal}
          end else if current=Hmenu then textcolor:=getcolor(3*256+5) {selektiert aber nicht aktivierbar}
          else textcolor:=getcolor(3*256+2); {nicht aktivierbar}
          schreibefeld(r.a.x+5,ypos,r.b.x-5,ypos+12,current<>Hmenu,false,text,textcolor,boxcolor);
        end else line(r.a.x+4,ypos,r.b.x-4,12,boxcolor);
        inc(ypos,13);
        hmenu:=hmenu^.next;
      end;
    end;
  end else if buffer<>nil then begin
    putimage(r.a.x,r.a.y,buffer^,normalput);
    freemem(buffer,imagesize(r.a.x,r.a.y,r.b.x,r.b.y));
  end;
  showmouse;
end;

procedure TMenuBox.setcurrent(NewCurrent: PMenuItem);
var R:TRect;
    textcolor,boxcolor:word;
    zeichen:byte;
begin
  correctViewPort;
  getbounds(r);
  zeichen:=(r.b.x-r.a.x-20) div 8;
  boxcolor:=getcolor(7*256+8); {Hintergrund und Rand}
  if (current<>nil) and (current^.name<>nil) then begin
    GetItemRect(current,R);
    if (current^.command=0) or commandenabled(current^.command)
    then textcolor:=getcolor(3*256+1) {Normal}
    else textcolor:=getcolor(3*256+2); {nicht aktivierbar}
    Schreiberamen(r.a.x,r.a.y,r.b.x,r.b.y,true,false,gettext(current,zeichen),textcolor,boxcolor);
  end;
  current:=newcurrent;
  if (current<>nil) and (current^.name<>nil) then begin
    GetItemRect(current,R);
    if (current^.command=0) or commandenabled(newcurrent^.command)
    then textcolor:=getcolor(6*256+4) {aktiviert}
    else textcolor:=getcolor(3*256+5); {selektiert aber nicht aktivierbar}
    Schreiberamen(r.a.x,r.a.y,r.b.x,r.b.y,false,false,gettext(current,zeichen),textcolor,boxcolor);
  end;
end;

procedure TMenuBox.GetItemRect(Item: PMenuItem; var R: TRect);{liefert lokale koordinaten}
var Hmenu:PMenuItem;
    eintragzahl:byte;
{    h:TRect;}
begin
  if menu<>nil then begin
    eintragzahl:=0;
    Hmenu:=Menu^.Items;
    while (hmenu<>nil) and (item<>hmenu) do begin
      inc(eintragzahl);
      hmenu:=hmenu^.next;
    end;
    if hmenu=nil then clearrec(r)
    else begin
      getextent(r);
{      owner^.getbounds(h);
      r.move(h.a.x,h.a.y);}
      inc(r.a.y,5+13*eintragzahl);
      r.b.y:=12+r.a.y;
      inc(r.a.x,5);
      dec(r.b.x,5);
    end;
  end else clearrec(r);
end;

constructor TStatusLine.Init(var Bounds: TRect; ADefs: PStatusDef);
begin
  TView.Init(Bounds);
  Defs:=ADefs;
  options:=ofselectable;
  eventmask:=evbroadcast + evMouse + evKeyDown;
  growmode:=gfgrowloy+gfgrowhix+gfgrowhiy;
  positionctx:=scNachUntenShape;
  if adefs=nil then items:=nil else items:=adefs^.items;
  current:=nil;
end;

constructor TStatusLine.Load(var S: TStream);
begin
  tview.load(s);
  current:=nil;
end;

destructor TStatusLine.Done;
var HStatusItem:PStatusItem;
    HStatusDef:PStatusDef;
begin
  TView.Done;
  while defs<>nil do begin
    while defs^.Items<>nil do begin
      disposestr(defs^.items^.text);
      HStatusItem:=defs^.items;
      defs^.items:=defs^.items^.next;
      dispose(HStatusitem);
    end;
    HStatusDef:=defs;
    defs:=defs^.next;
    dispose(HStatusDef);
  end;
end;

procedure TStatusLine.GetItemRect(aktItem:PStatusItem;var r:TRect);{liefert lokale koordinaten des aktuellen eintrags}
var xpos:word;
    Item:PStatusItem;
begin
  if aktitem<>nil then begin
    Item:=Items;
    xpos:=0;
    while (item<>nil) and (item<>aktitem) do begin
      if item^.text<>nil then inc(xpos,succ((cstrlen(item^.text^)+2)*8));
      item:=item^.next;
    end;
    getextent(r);
    r.a.x:=xpos;
    if item^.text<>nil then r.b.x:=r.a.x+(cstrlen(item^.text^)+2)*8
    else r.b.x:=r.a.x;
  end else clearrec(r);
end;

procedure TStatusLine.setcurrent(NewCurrent: PStatusItem);
var R:TRect;
    textcolor,boxcolor:word;
begin
  correctViewPort;
  boxcolor:=getcolor(7*256+8); {Hintergrund und Rand}
  if (current<>nil) and (current^.text<>nil) then begin
    GetItemRect(current,R);
    if commandenabled(current^.command)
    then textcolor:=getcolor(3*256+1) {Normal}
    else textcolor:=getcolor(3*256+2); {nicht aktivierbar}
    Schreiberamen(r.a.x,r.a.y,r.b.x,r.b.y,true,true,current^.text^,textcolor,boxcolor);
  end;
  current:=newcurrent;
  if (current<>nil) and (current^.text<>nil) then begin
    GetItemRect(current,R);
    if commandenabled(current^.command)
    then textcolor:=getcolor(6*256+4) {aktiviert}
    else textcolor:=getcolor(3*256+5); {selektiert aber nicht aktivierbar}
    Schreiberamen(r.a.x,r.a.y,r.b.x,r.b.y,false,true,current^.text^,textcolor,boxcolor);
  end;
end;

procedure TStatusLine.Draw;
var r:Trect;
    item:PStatusItem;
    xpos,leng,textcolor,boxcolor:word;
begin
  boxcolor:=getcolor(7*256+8); {Hintergrund und Rand}
  getextent(r);
  {ramen(r.a.x,r.a.y,r.b.y,r.b.y);}
  Item:=Items;
  xpos:=0;
  hidemouse;
  while item<>nil do begin
    if item^.text<>nil then begin
      leng:=(cstrlen(item^.text^)+2)*8;
      if commandenabled(item^.command) then begin
        if current=item then textcolor:=getcolor(6*256+4) else  {aktiviert}
        textcolor:=getcolor(3*256+1) {Normal}
      end else if current=Item then textcolor:=getcolor(3*256+5) {selektiert aber nicht aktivierbar}
      else textcolor:=getcolor(3*256+2); {nicht aktivierbar}
      schreibefeld(r.a.x+xpos,r.a.y,r.a.x+xpos+leng,r.b.y,current<>item,true,item^.text^,textcolor,boxcolor);
      inc(xpos,succ(leng));
    end;
    item:=item^.next;
  end;
  feld(r.a.x+xpos,r.a.y,r.b.x,r.b.y,true,boxcolor);
  showmouse;
end;

function TStatusLine.GetPalette: PPalette;
const
  CStatusLine = #2#3#4#5#6#7#1#78;
  PStatusLine: String[length(CStatusLine)] = CStatusLine;
begin
  getpalette:= @PStatusLine;
end;

procedure TStatusLine.HandleEvent(var Event: TEvent);
var last,item:PStatusItem;
    xpos:word;
    neuevent:Tevent;
begin
  if event.what and positionalevents>0 then begin     {Mausereignis}
    if (MouseButtons>0) or ((event.what and evmouseup)>0) then begin
      Item:=Items;
      last:=nil;
      xpos:=0;
      while (item<>nil) and (xpos<=event.where.x) do begin
        last:=item;
        if item^.text<>nil then inc(xpos,succ((cstrlen(item^.text^)+2)*8));
        item:=item^.next;
      end;
      if last<>nil then begin                          {Wenn im Menu}
        if event.what and evmouseup>0 then begin      {Wenn Maus losgelassen}
          if commandenabled(last^.command) then begin
            neuevent.what:=evcommand;
            neuevent.command:=last^.command;
            putevent(neuevent);
          end;
          if current<>nil then setcurrent(nil);
        end else if last<>current then setcurrent(last);
        clearevent(event);
      end else if current<>nil then setcurrent(nil);
    end else if current<>nil then setcurrent(nil);
  end else begin
    if event.what= evkeydown then begin
      item:=items;
      while (item<>nil) and (item^.keycode<>event.keycode) do item:=item^.next;
      if item<>nil then begin
        if commandenabled(item^.command) then begin
          neuevent.what:=evcommand;
          neuevent.command:=item^.command;
          putevent(neuevent);
        end;
        clearevent(event);
      end;
    end;
  end;
end;

function TStatusLine.Hint(AHelpCtx: Word):String; 
begin
  hint:='';
end;

procedure TStatusLine.Store(var S: TStream);
begin
  TView.store(s);
end;

procedure TStatusLine.Update(ctx:word);
var Def:PStatusDef;
    olditem:PStatusItem;
    r:TRect;
begin
  olditem:=items;
  def:=defs;
  while (def<>nil) and ((ctx>def^.max) or (ctx<def^.min))
  do def:=def^.next;
  if def<>nil then items:=def^.items else begin
    if defs<>nil then items:=defs^.items else items:=nil;
  end;
  getbounds(r);
  if ((current<>nil) and (not positionin(mousewhere,r))) or
   ((items<>olditem) and (items<>nil)) then begin
    current:=nil;
    correctviewport;
    draw;
  end;
end;

const SenkrechtShape:TShape = (relx:7;rely:0;
      shape : (screen : ($FC3F,$F81F,$F81F,$F18F,
                         $F18F,$E3C7,$E007,$E007,
                         $E007,$FC3F,$FC3F,$FC3F,
                         $FC3F,$FC3F,$FC3F,$FC3F);
               mask   : ($0000,$0180,$03C0,$0240,
                         $0660,$0420,$0FF0,$0DB0,
                         $0180,$0180,$0180,$0180,
                         $0180,$0180,$0180,$0000));
          number:scSenkrechtShape);
      NachUntenShape:TShape = (relx:7;rely:15;
      shape : (screen : ($FC3F,$FC3F,$FC3F,$FC3F,
                         $FC3F,$FC3F,$E427,$E007,
                         $E007,$E3C7,$E3C7,$F18F,
                         $F18F,$F81F,$F81F,$FC3F);
               mask   : ($0000,$0180,$0180,$0180,
                         $0180,$0180,$0180,$0990,
                         $0FF0,$0C30,$0420,$0660,
                         $0240,$03C0,$0180,$0000));
          number:scNachUntenShape);
       NachRechtsShape:TShape = (relx:15;rely:7;
      shape : (screen : ($FFFF,$FFFF,$FFFF,$F83F,
                         $F80F,$FC03,$00C0,$00F0,
                         $00F0,$00C0,$FC03,$F80F,
                         $F83F,$FFFF,$FFFF,$FFFF);
               mask   : ($0000,$0000,$0000,$0000,
                         $0380,$01E0,$0138,$7F0E,
                         $7F0E,$0138,$01E0,$0380,
                         $0000,$0000,$0000,$0000));
          number:scNachRechtsShape);

begin
  MouseCursor^.RegisterShape(@SenkrechtShape);
  MouseCursor^.RegisterShape(@NachUntenShape);
  MouseCursor^.RegisterShape(@NachRechtsShape);
end.