unit vga;
interface
uses dos;
Type PPalette=^TPalette;
     TPalette=array[0..255,0..2] of byte;
var seite:byte;
const R320x240=1;
      R320x400=2;
      R360x480=3;
      R640x400=4;
      max_X:word=320;
      max_y:word=200;
      aktRes:byte=0;

procedure SetMode(Resolution:byte);
procedure paint(s:byte);
procedure show(s:byte);
procedure setpoint(x,y:word;f:byte);
function getpoint(x,y:word):byte;

procedure videomodus(modus:byte);
function videomoduslesen:byte;
procedure plot(x,y:word;farbe:byte);
function getpixel(x,y:word):byte;
procedure farbe(register:word;rot,gruen,blau:byte);
procedure lesefarbe(register:word;var r,g,b:byte);
procedure map(mask:byte);
procedure readmap(nummer:byte);
procedure bitmask(mask:byte);
procedure color(mask:byte);
procedure videoseite(neueseite:byte);
procedure vgaende;
procedure scqmode;
procedure scqplot(x,y:integer;color:byte);
function scqgetpixel(x,y:integer):byte;
procedure ladetextromzs(block:byte);
procedure vgaleseseite(seite:byte);
procedure vgaschreibeseiten(seiten:byte);
procedure waitsync;
procedure farbblock(anfang,anzahl:word;block:PPalette);
procedure farbblocklesen(anfang,anzahl:word;block:PPalette);
procedure farbblockshade(anfang,anzahl:word;block:PPalette;anztrick:word);
procedure farbshade(anfang,anzahl:word;block:PPalette);
procedure overscan(c:byte);
procedure shadein(x:byte;pal:ppalette);
procedure shadeout(x:byte;pal:ppalette);
procedure setpalette(pal:ppalette);
procedure cursorhohe(ya,ye:byte);
procedure getcursorhohe(var ya,ye:byte);

implementation
const modusgeandert:boolean=false;
var regs:registers;
    altseite,altmodus:byte;
    oldexitproc:pointer;

Type TCrt=Array[0..$17] of byte;
const Crt320x240:TCrt=($5f,$4f,$50,$82,$54,$80,$0d,$3e,$00,$41,$00,$00,
                       $00,$00,$00,$00,$ea,$ac,$df,$28,$00,$e7,$06,$e3);
      Crt320x400:TCrt=($5f,$4f,$50,$82,$54,$80,$bf,$1f,$00,$40,$00,$00,
                       $00,$00,$00,$00,$9c,$8e,$8f,$28,$00,$96,$b9,$e3);
      Crt360x480:TCrt=($6b,$59,$5a,$8e,$5e,$8a,$0d,$3e,$00,$40,$00,$00,
                       $00,$00,$00,$00,$ea,$ac,$df,$2d,$00,$e7,$06,$e3);
      Crt640x400:TCrt=($5f,$4f,$50,$82,$54,$80,$bf,$1f,$00,$40,$00,$00,
                       $00,$00,$00,$00,$9c,$8e,$8f,$28,$00,$96,$b9,$a3);
var zb4:byte;
const page:word=$a000;

procedure SetMode(Resolution:byte);
var regs:registers;
    nr:byte;
begin
  regs.ah:=0;
  regs.al:=$12;
  intr($10,regs);
  regs.ah:=0;
  regs.al:=$13;
  intr($10,regs);
  port[$3c4]:=4;
  port[$3c5]:=6;
  port[$3d4]:=$11;
  port[$3d5]:=port[$3d5] and $7f;
  case resolution of
    R320x240:begin
      port[$3c4]:=0;
      port[$3c5]:=1;
      port[$3c2]:=$e3;
      port[$3c4]:=0;
      port[$3c5]:=3;
      for nr:=0 to $17 do  begin
        port[$3d4]:=nr;
        port[$3d5]:=crt320x240[nr];
      end;
      zb4:=80;
      max_X:=319;
      max_y:=239;
    end;
    R320x400:begin
      for nr:=0 to $17 do  begin
        port[$3d4]:=nr;
        port[$3d5]:=crt320x400[nr];
      end;
      zb4:=80;
      max_X:=319;
      max_y:=399;
    end;
    R360x480:begin
      port[$3c4]:=0;
      port[$3c5]:=1;
      port[$3c2]:=$e7;
      port[$3c4]:=0;
      port[$3c5]:=3;
      for nr:=0 to $17 do  begin
        port[$3d4]:=nr;
        port[$3d5]:=crt360x480[nr];
      end;
      zb4:=90;
      max_X:=359;
      max_y:=479;
    end;
    R640x400:begin
      for nr:=0 to $17 do  begin
        port[$3d4]:=nr;
        port[$3d5]:=crt640x400[nr];
      end;
      zb4:=160;
      max_X:=639;
      max_y:=399;
    end;
  end;
  aktRes:=resolution;
  modusgeandert:=true;
end;

procedure paint(s:byte);
begin
  case aktres of
    R320x240:case s of
        2:page:=$a4b0;
        3:page:=$a960;
        else page:=$a000;
      end;
    R320x400:if s=2 then page:=$a800 else page:=$a000;
    R360x480,R640x400:page:=$a000;
    else page:=$a000;
  end;
end;

procedure show(s:byte);
var start:byte;
begin
  case aktres of
    R320x240:case s of
        2:start:=$4b;
        3:start:=$96;
        else start:=$00;
      end;
    R320x400:if s=2 then start:=$80 else start:=$00;
    R360x480,R640x400:start:=$00;
    else start:=$00;
  end;
  port[$3d4]:=$0c;
  port[$3d5]:=start;
  modusgeandert:=true;
end;

procedure setpoint(x,y:word;f:byte);
begin
  port[$3c4]:=2;
  port[$3c5]:=1 shl (x and 3);
  mem[page:y*zb4+(x shr 2)]:=f;
end;

function getpoint(x,y:word):byte;
begin
  port[$3ce]:=4;
  port[$3cf]:=x and 3;
  getpoint:=mem[page:y*zb4+(x shr 2)];
end;

{$F+}
procedure myownexitproc;
begin
  vgaende;
  exitproc:=oldexitproc;
end;
{$f-}

procedure videomodus(modus:byte);
begin
  with regs do begin
    ah:=0;al:=modus;intr($10,regs);
    seite:=1;
  end;
  modusgeandert:=true;
end;

function videomoduslesen:byte;
begin
  with regs do begin
    ah:=$0f;intr($10,regs);
    seite:=bh;videomoduslesen:=al;
  end;
end;

procedure plot(x,y:word;farbe:byte);
begin
  mem[$A000:x+320*y]:=farbe;
{  with regs do begin
    ah:=$0c;al:=farbe;cx:=x;dx:=y;bh:=seite;intr($10,regs);
  end}
end;

function getpixel(x,y:word):byte;
begin
  getpixel:=mem[$A000:x+320*y];
end;

procedure farbe(register:word;rot,gruen,blau:byte);
begin
  with regs do begin
    ax:=$1010;bx:=register;ch:=gruen;cl:=blau;dh:=rot;intr($10,regs);
  end;
end;

procedure lesefarbe(register:word;var r,g,b:byte);
begin
  with regs do begin
    ax:=$1015;bx:=register;intr($10,regs);g:=ch;b:=cl;r:=dh;
  end;
end;

procedure map(mask:byte);
begin
  port[$3c4]:=2;
  port[$3c5]:=mask;
end;

procedure bitmask(mask:byte);
begin
  port[$3ce]:=8;
  port[$3cf]:=mask;
end;

procedure color(mask:byte);
begin
  port[$3ce]:=0;
  port[$3cf]:=mask;
end;

procedure readmap(nummer:byte);
begin
  port[$3ce]:=4;
  port[$3cf]:=nummer and 3;
end;

procedure videoseite(neueseite:byte);
begin
  with regs do begin
    seite:=neueseite;
    ah:=$05;al:=neueseite;intr($10,regs);
  end;
  modusgeandert:=true;
end;

procedure vgaleseseite(seite:byte);
begin
  port[$3ce]:=4;
  port[$3cf]:=seite and 3;
end;

procedure vgaschreibeseiten(seiten:byte);
begin
  port[$3c4]:=2;
  port[$3c5]:=seiten and $0f;
end;

procedure vgaende;
begin
  if modusgeandert then begin
    videomodus(altmodus);
    videoseite(altseite);
  end;
end;

procedure scqmode;
const reg_wert:array[0..$17] of byte=
      ($6b,$59,$5a,$8e,$5e,$8a,$0d,$3e,
       $ff,$40,$ff,$ff,$ff,$ff,$ff,$ff,
       $ea,$ac,$df,$2d,$00,$e7,$06,$e3);
var lese,zaehler:byte;
begin
  videomodus($12);
  videomodus($13);
  port[$3c4]:=4;
  port[$3c5]:=6;
  port[$3c4]:=0;
  port[$3c5]:=1;
  port[$3c2]:=$e7;
  port[$3c4]:=0;
  port[$3c5]:=3;
  port[$3d4]:=$11;
  lese:=(port[$3d5] and $7f);
  port[$3d5]:=lese;
  for zaehler:=0 to $17 do begin
    if reg_wert[zaehler]<>$FF then begin
      port[$3d4]:=zaehler;
      port[$3d5]:=reg_wert[zaehler];
    end;
  end;
  modusgeandert:=true;
end;

procedure scqplot(x,y:integer;color:byte);
begin
  if ((x>=0) and (y>=0) and (x<360) and (y<480)) then begin
{$r-}
    port[$03c4]:=2;
    port[$03c5]:=1 shl (x and 3);
    mem[$a000:y*90+ (x shr 2)]:=color; {$r+}
  end;
end;

function scqgetpixel(x,y:integer):byte;
begin
{$r-}
  port[$03cE]:=4;
  port[$03cf]:=x and 3;
  scqgetpixel:=mem[$a000:y*90+ (x shr 2)];
{$r+}
end;

procedure ladetextromzs(block:byte);
begin
  with regs do begin
    ax:=$1104;bl:=block;
    intr($10,regs);
  end;
end;

procedure waitsync;
begin
  asm
         mov  dx,$3da
         mov  ah,8
{  @wait2:in   al,dx
         test al,ah
         jnz  @wait2}
  @wait4:in   al,dx
         test al,ah
         jz   @wait4
  end;
end;

procedure farbblock(anfang,anzahl:word;block:PPalette);
{var regs:registers;}
var segb,ofsb:word;
begin
  segb:=seg(block^);
  ofsb:=ofs(block^);
  asm
   PUSH    DS
   mov bx,anfang;
   mov cx,anzahl;
   mov ds,segb;
   mov si,ofsb;
   CLD
   mov  dx,$3da
   mov  ah,8
@wait:in al,dx
   test al,ah
   jz  @wait
   CLI
   MOV	DX,$03C8
   MOV AL,BL
   OUT	DX,AL
   INC	DX

@1:LODSW
   OUT	DX,AL
   MOV	AL,AH
   OUT	DX,AL
   LODSB
   OUT	DX,AL
   LOOPNZ @1

   STI
   POP	DS
  end;
{  with regs do begin
    ax:=$1012;
    bx:=anfang;
    cx:=anzahl;
    es:=seg(block^);
    dx:=ofs(block^);
    intr($10,regs);
  end;        }
end;

procedure farbblockshade(anfang,anzahl:word;block:PPalette;anztrick:word);
var segb,ofsb:word;
begin
  segb:=seg(block^);
  ofsb:=ofs(block^);
  asm
   PUSH    DS
   mov bx,anfang
   mov cx,anzahl
   mov ax,anztrick
   sub cx,ax
   mov ds,segb
   mov si,ofsb
   CLD
   mov  dx,$3da
   mov  ah,8
@wait:in al,dx
   test al,ah
   jz  @wait
   CLI
   MOV	DX,$03C8
   MOV AL,BL
   OUT	DX,AL
   INC	DX

@1:LODSW
   OUT	DX,AL
   MOV	AL,AH
   OUT	DX,AL
   LODSB
   OUT	DX,AL
   LOOPNZ @1

   mov cx,anztrick
@2:
   LODSW
   OUT	DX,AL
   MOV	AL,AH
   OUT	DX,AL

   MOV DX,$03DA
@WAIT1: IN AL,DX
   TEST AL,1
   JNZ @WAIT1
@WAIT2: IN AL,DX
   TEST AL,1
   JZ @WAIT2
   MOV DX,$3C9

   LODSB
   OUT	DX,AL
   LOOPNZ @2

   STI
   POP	DS
  end;
end;

procedure farbshade(anfang,anzahl:word;block:PPalette);
var segb,ofsb:word;
begin
  segb:=seg(block^);
  ofsb:=ofs(block^);
  asm
   PUSH    DS
   mov bx,anfang;
   mov cx,anzahl;
   mov ds,segb;
   mov si,ofsb;
   CLD
   CLI
   MOV	DX,$03C8
   MOV AL,BL
   OUT	DX,AL
   INC	DX
@2:
   LODSW
   OUT	DX,AL
   MOV	AL,AH
   OUT	DX,AL

   MOV DX,$03DA
@WAIT1: IN AL,DX
   TEST AL,1
   JNZ @WAIT1
@WAIT2: IN AL,DX
   TEST AL,1
   JZ @WAIT2
   MOV DX,$3C9

   LODSB
   OUT	DX,AL
   LOOPNZ @2

   STI
   POP	DS
  end;
end;

procedure farbblocklesen(anfang,anzahl:word;block:PPalette);
var regs:registers;
begin
  with regs do begin
    ax:=$1017;
    bx:=anfang;
    cx:=anzahl;
    es:=seg(block^);
    dx:=ofs(block^);
    intr($10,regs);
  end;
end;

procedure overscan(c:byte);
var regs:registers;
begin
  with regs do begin
    ax:=$1001;
    bh:=c;
    intr($10,regs);
  end;
end;

procedure shadein(x:byte;pal:ppalette);
var aktpal:TPalette;
    n:word;
    c,r:byte;
begin
  for n:=1 to 32 do begin
    for c:=x to 255 do for r:=0 to 2 do aktpal[c-x,r]:=byte(word(pal^[c,r])*word(n) div 32);
    farbblockshade(x,256-x,@aktpal,100-x);
  end;
end;

procedure shadeout(x:byte;pal:ppalette);
var aktpal:TPalette;
    n:word;
    c,r:byte;
begin
  for n:=32 downto 0 do begin
    for c:=x to 255 do for r:=0 to 2 do aktpal[c-x,r]:=byte(word(pal^[c,r])*word(n) div 32);
    farbblockshade(x,256-x,@aktpal,100-x);
  end;
end;

procedure setpalette(pal:ppalette);
begin
  farbblockshade(0,256,pal,100);
end;

procedure cursorhohe(ya,ye:byte);
begin
  port[$3d4]:=$A;
  port[$3d5]:=ya;
  port[$3d4]:=$b;
  port[$3d5]:=ye;
end;

procedure getcursorhohe(var ya,ye:byte);
begin
  port[$3d4]:=$A;
  ya:=port[$3d5];
  port[$3d4]:=$b;
  ye:=port[$3d5];
end;

begin
  altmodus:=videomoduslesen;
  altseite:=seite;
  oldexitproc:=exitproc;
  exitproc:=@myownexitproc;
end.